/*
 * Persistent Systems Private Limited, Pune, India (website - http://www.persistent.co.in)
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that this
 * copyright notice and the following paragraph appears in all
 * copies of this software.
 *
 * DISCLAIMER OF WARRANTY.
 * -----------------------
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
 * IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef CONTENT_BUFFER_H
#define CONTENT_BUFFER_H

/*
* This class represents string content inside an element.
* Similar to StringBuffer in java.
*
*/
//Date created - 21 Feb 2003

#include "VOTGlobal.h"
#include <sax2/SAX2XMLReader.hpp>
#include <util/PlatformUtils.hpp>

class ContentBuffer 
{
public:

	/**
	* Default constructor.
	*/
	ContentBuffer();

	/**
	* Destructor.
	*/
	~ContentBuffer();

	/**
	* Assignment operator overloaded.
	*/
	ContentBuffer operator=(const ContentBuffer &cb);

	/**
	* Copy constructor.
	*/
	ContentBuffer(const ContentBuffer &cb);
	
	
	ContentBuffer(const XMLCh* const chars, const unsigned int length);
	void append(const XMLCh* const chars, const unsigned int length);	
	void reset(void);

	/**
	* Get content of buffer.
	*/
	XMLCh * getContent (void);

private:
	/*
	* Actual content.
	*/
	XMLCh * m_content;

	/*
	* Lenght of complete buffer.
	*/
	int m_totalLength;	

	int copyString(XMLCh * dest, const XMLCh* const src);
	int concatString(XMLCh * dest, const XMLCh* const src);
	
	void makecopy(const ContentBuffer &cb);
	void cleanup(void);
	void init(void);

};

#endif