/*
 * Persistent Systems Private Limited, Pune, India (website - http://www.persistent.co.in)
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that this
 * copyright notice and the following paragraph appears in all
 * copies of this software.
 *
 * DISCLAIMER OF WARRANTY.
 * -----------------------
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
 * IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef HANDLER_CONTEXT_H
#define HANDLER_CONTEXT_H

#include "StructureHandler.h"

/*
* This class is used for storing the conext of a handler
* that is added in the stack for later used.
* 
* The handler context is retrieved at proper end element
* depending on nesting and context depth in PParse.
*/
class HandlerContext
{
public:

	/**
	* Default Constructor
	*/
	HandlerContext();

	/**
	* Destructor
	*/
	~HandlerContext();

	/**
	* Constructor that takes depth of handler and handler as input.
	*/
	HandlerContext(int depth, StructureHandler *handler);

	/**
	* Get depth of this handler.
	*/
	int getDepth();

	/**
	* Get handler.
	*/
	StructureHandler * getHandler(); 

private:
	// Depth
	int m_depth;

	// Handler
	StructureHandler *m_handler;

};

#endif