/*
 * Persistent Systems Private Limited, Pune, India (website - http://www.persistent.co.in)
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that this
 * copyright notice and the following paragraph appears in all
 * copies of this software.
 *
 * DISCLAIMER OF WARRANTY.
 * -----------------------
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
 * IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef STRUCTURE_HANDLER_H
#define STRUCTURE_HANDLER_H

#include <sax2/Attributes.hpp>
#include <sax2/DefaultHandler.hpp>
#include <iostream.h>
#include <stdio.h>

#include "VOUtils.h"
XERCES_CPP_NAMESPACE_USE

class StructureHandler
{
public:

	virtual void startElement(const XMLCh* const qname, const Attributes& attrs);

	virtual void startElement();

	virtual void endElement(const XMLCh* const qname, const XMLCh* const chars,
						  const unsigned int length);

	virtual StructureHandler *startChild(const XMLCh* const qname, const Attributes& attrs) ;

	virtual void endDirectChild(const XMLCh* const qname, const XMLCh* const chars,
						  const unsigned int length);

	virtual void endStructureChild(const XMLCh* const qname, StructureHandler *handler);

protected:
	virtual void doNothing(void)=0;
};

#endif