/*
 * Persistent Systems Private Limited, Pune, India (website - http://www.persistent.co.in)
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that this
 * copyright notice and the following paragraph appears in all
 * copies of this software.
 *
 * DISCLAIMER OF WARRANTY.
 * -----------------------
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
 * IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef VOTABLE_DEFINITION_H
#define VOTABLE_DEFINITION_H

#include "VOTCoosys.h"
#include "VOTParam.h"

/**
* This class represents the &lt;DEFINITION&gt; element. 
*/

/// This class represents the &lt;DEFINITION&gt; element. 

class VOTDefinition
{
public:

	/**
	* Default constructor
	*/
	VOTDefinition();

	/**
	* Destructor
	*/
	~VOTDefinition();

	/**
	* Assignment operator overloaded.
	*/
	VOTDefinition operator=(const VOTDefinition &votDefinition);

	/**
	* Copy Constructor
	*/
	VOTDefinition(const VOTDefinition &votDefinition);

	/**
	* Get Coosys element.
	*/
	int getCoosys(VOTCoosys * &coosys);	

	/*
	* Set Coosys
	*/
	int setCoosys(VOTCoosys coosys);	

	/**
	* Get Param element.
	*/
	int getParam(VOTParam * &param);	

	/*
	* Set Param.
	*/
	int setParam(VOTParam param);
	

private:
	// Coosys element.
	VOTCoosys * m_coosys;

	// Param element.
	VOTParam * m_param;

	void cleanup();
	void makecopy(const VOTDefinition &c);
	void init(void);

};

#endif
