/*
 * Persistent Systems Private Limited, Pune, India (website - http://www.persistent.co.in)
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that this
 * copyright notice and the following paragraph appears in all
 * copies of this software.
 *
 * DISCLAIMER OF WARRANTY.
 * -----------------------
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
 * IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */
#ifndef VOTABLE_DESC_H
#define VOTABLE_DESC_H

#include "VOTGlobal.h"

/**
* This class represents the &lt;DESCRIPTION&gt; element. 
*/

/// This class represents the &lt;DESCRIPTION&gt; element

class VOTDescription
{
public:

	/**
	* Default constructor
	*/
	VOTDescription();

	/**
	* Destructor
	*/
	~VOTDescription();

	/**
	* Assignment operator overloaded.
	*/
	VOTDescription operator=(const VOTDescription &votdesc);

	/**
	* Copy Constructor
	*/
	VOTDescription(const VOTDescription &votdesc);

	/**
	* Get description data.
	*/
	int getData(char * &desc);
	
	/*
	* Set description data.
	*/
	int setData(char * desc);

	void reset(void);	

private:

	// Description text.
	char * m_data;

	void makecopy(const VOTDescription &votdesc);
	void cleanup(void);
	void init(void);
	
};

#endif
