/*
 * Persistent Systems Private Limited, Pune, India (website - http://www.pspl.co.in)
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that this
 * copyright notice and the following paragraph appears in all
 * copies of this software.
 *
 * DISCLAIMER OF WARRANTY.
 * -----------------------
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
 * IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef VOTABLE_INFO_H
#define VOTABLE_INFO_H

#include "VOTGlobal.h"

/**
* This class represents &lt;INFO&gt; element in a &lt;RESOURCE&gt;.  
*
* A &lt;INFO&gt; element contains ID, name and value.
* 
*/

/// This class represents &lt;INFO&gt; element in a &lt;RESOURCE&gt;

//Date created - 27 May 2002

class VOTInfo {

	public:
		/**
		* Default constructor
		*/
		VOTInfo();

		/**
		* Destructor
		*/
		~VOTInfo();

		/**
		* Assignment operator overloaded.
		*/
		VOTInfo operator=(const VOTInfo &info);

		/**
		* Copy constructor.
		*/
		VOTInfo(const VOTInfo &info);
		
		/**
		* Gets the 'value' attribute.
		*/
		int getValue(char * &infovalue);

		/**
		* Gets the 'ID' attribute.
		*/
		int getID(char * &infoID);

		/**
		* Gets the 'name' attribute.
		*/
		int getName(char * &infoName);

		/*
		* Gets the 'PCDATA'.
		*/
		int getPCData(char * &pcdata);

		/**
		 * Reinitializes all the data structures in the class
		 */
		void reset(void);
	
		int setValue(char * infoValue);
		int setID(char * infoID);
		int setName(char * infoName);
		int setPCData(char * pcdata);

	private: 
		char * m_ID;
		char * m_name;
		char * m_infoValue;
		char * m_pcdata;
		
		void cleanup();
		void makecopy(const VOTInfo &r);
		void init(void);
};

#endif
