/*
 * Persistent Systems Private Limited, Pune, India (website - http://www.pspl.co.in)
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that this
 * copyright notice and the following paragraph appears in all
 * copies of this software.
 *
 * DISCLAIMER OF WARRANTY.
 * -----------------------
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
 * IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef VOT_PARAM_H
#define VOT_PARAM_H

#include "VOTFieldParam.h"

/**
* 
* A 'Param' contains description, a max of 2 values and a
* list of links. This class is derived from the abstract class
* 'FieldParam'.
*
*/

/// This class represents &lt;PARAM&gt; element.

//Date created - 03 May 2002

class VOTParam : public VOTFieldParam {

	public:

		/**
		* Default constructor.
		*/
		VOTParam();

		/**
		* Default destructor
		*/
		~VOTParam();

		/**
		* Assignment operator overloaded.
		*/
		VOTParam operator=(const VOTParam &param);

		/**
		* Copy constructor.
		*/
		VOTParam(const VOTParam &param);

		/**
		* Gets the 'value'.
		*/
		int getValue(char * &value);

		// Sets the 'value'
		int setValue(char * value);

		/*
		* Reinitializes all the data structures in the class
		*/
		void reset(void);

	private:

		// Value of the PARAM
		char * m_paramValue;

		// Dummy function - does nothing
		void doNothing(void);
		
		// Initialises the data in the class
		void init(void);

		// Delete all data stored in the class
		void cleanup(void);
		
		// Copies all data from the passed object to <i>this</i> object
		void makecopy(const VOTParam &p);
};

#endif
