/*
 * Persistent Systems Private Limited, Pune, India (website - http://www.pspl.co.in)
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that this
 * copyright notice and the following paragraph appears in all
 * copies of this software.
 *
 * DISCLAIMER OF WARRANTY.
 * -----------------------
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
 * IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef VOT_TABLEDATA_H
#define VOT_TABLEDATA_H

#include "VOTGlobal.h"
#include "VOTRow.h"
#include <vector>
using namespace std;

/**
* This class represents the table data, &lt;TABLEDATA&gt; in a &lt;TABLE&gt;.  
* 
* TableData consists of list of 'Row' objects. 
*
*/

/// This class represents the table data, &lt;TABLEDATA&gt; in a &lt;TABLE&gt;

// Date created - 03 May 2002

class VOTTableData {

	public:
		/**
		* Default Constructor
		*/
		VOTTableData();

		/**
		* Destructor
		*/
		~VOTTableData();

		/**
		* Gets total number of rows.
		*/
		int getNumOfRows(int  &nrows);

		/**
		* Gets the 'Row', given the index.
		* Index starts at 0.
		*/
		int getRow(VOTRow &row, int index);		

		// called internally
		void cleanup();

		// Sets the vector for VOTRow
		int setRows(vector<VOTRow> rowList);

		// Adds a VOTRow to the vector
		int addRow(VOTRow oneRow);
	
	private: 
		// Vector for storing VOTRow
		vector<VOTRow> m_rowList;
};

#endif
